import { validateRelations } from 'src/core/strings/constants/interface.constants';
import { BaseManager } from '../base.manager';

export abstract class BaseCustomManager<Entity> extends BaseManager {
  protected result: any;
  abstract get entityTarget(): any;

  setData(entity: Entity): void {
    this.data = entity;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  async prepareData(): Promise<void> {
    if (this.data)
      Object.assign(this.data, {
        editor_id: this.user.id,
        editor_name: this.user.name,
        updated_at: new Date().getTime(),
      });
  }

  abstract getResult(): any;
}
