import { BaseCustomManager } from 'src/core/modules/domain/usecase/managers/base-custom.manager';
import { EventTopics } from 'src/core/strings/constants/interface.constants';
import { UserModel } from 'src/modules/user-related/user/data/models/user.model';
import { UserEntity } from 'src/modules/user-related/user/domain/entities/user.entity';
import { UserLogoutEvent } from '../entities/logout.event';

export class LogoutManager extends BaseCustomManager<UserEntity> {
  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async process(): Promise<void> {
    await this.dataService.update(
      this.queryRunner,
      this.entityTarget,
      { id: this.user.id },
      {
        refresh_token: null,
      },
    );

    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  getResult() {
    return `Success Logout user`;
  }

  get entityTarget(): any {
    return UserModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: UserLogoutEvent,
        data: {
          id: this.user.id,
          type: 'logout',
          timestamp: new Date().getTime(),
        },
      },
    ];
  }
}
