import { Module } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';
import { CqrsModule } from '@nestjs/cqrs';
import { IndexHolidayCalendarManager } from '../../configuration/google-calendar/domain/usecases/managers/index-holiday-google-calendar.manager';
import { GoogleCalendarController } from './infrastructure/google-calendar.controller';
import { GoogleCalendarOrchestrator } from './domain/usecases/google-calendar.orchestrator';

@Module({
  imports: [ConfigModule.forRoot(), CqrsModule],
  controllers: [GoogleCalendarController],
  providers: [IndexHolidayCalendarManager, GoogleCalendarOrchestrator],
})
export class GoogleCalendarModule {}
