import { Injectable } from '@nestjs/common';
import { DetailProfitShareFormulaManager } from './managers/detail-profit-share-formula.manager';
import { TABLE_NAME } from 'src/core/strings/constants/table.constants';
import { SalesPriceFormulaReadService } from 'src/modules/transaction/sales-price-formula/data/services/sales-price-formula-read.service';
import { SalesPriceFormulaEntity } from 'src/modules/transaction/sales-price-formula/domain/entities/sales-price-formula.entity';

@Injectable()
export class ProfitShareFormulaReadOrchestrator {
  constructor(
    private detailManager: DetailProfitShareFormulaManager,
    private serviceData: SalesPriceFormulaReadService,
  ) {}

  async detail(): Promise<SalesPriceFormulaEntity> {
    this.detailManager.setData('');
    this.detailManager.setService(this.serviceData, TABLE_NAME.PRICE_FORMULA);
    await this.detailManager.execute();
    return this.detailManager.getResult();
  }
}
