import { Injectable } from '@nestjs/common';
import { BaseIndexManager } from 'src/core/modules/domain/usecase/managers/base-index.manager';
import { TransactionEntity } from '../../entities/transaction.entity';
import { SelectQueryBuilder } from 'typeorm';
import {
  Param,
  RelationParam,
} from 'src/core/modules/domain/entities/base-filter.entity';

@Injectable()
export class IndexTransactionManager extends BaseIndexManager<TransactionEntity> {
  async prepareData(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get relations(): RelationParam {
    return {
      // relation only join (for query purpose)
      joinRelations: [],

      // relation join and select (relasi yang ingin ditampilkan),
      selectRelations: ['items'],

      // relation yang hanya ingin dihitung (akan return number)
      countRelations: [],
    };
  }

  get selects(): string[] {
    return [
      `${this.tableName}.id`,
      `${this.tableName}.status`,
      `${this.tableName}.invoice_code`,
      `${this.tableName}.booking_date`,
      `${this.tableName}.no_of_group`,
      `${this.tableName}.type`,
      `${this.tableName}.payment_total`,
      `${this.tableName}.customer_type`,
      `${this.tableName}.customer_name`,
      `${this.tableName}.customer_phone`,
      `${this.tableName}.customer_description`,
      `${this.tableName}.customer_email`,
      `${this.tableName}.invoice_date`,
      `${this.tableName}.settlement_date`,
      `${this.tableName}.created_at`,
      `${this.tableName}.creator_name`,
      `${this.tableName}.editor_id`,
      `${this.tableName}.editor_name`,
    ];
  }

  get specificFilter(): Param[] {
    return [
      {
        cols: `${this.tableName}.name`,
        data: this.filterParam.names,
      },
    ];
  }

  setQueryFilter(
    queryBuilder: SelectQueryBuilder<TransactionEntity>,
  ): SelectQueryBuilder<TransactionEntity> {
    queryBuilder.andWhere(`${this.tableName}.is_recap_transaction is false`);
    return queryBuilder;
  }
}
