import { BaseCustomManager } from 'src/core/modules/domain/usecase/managers/base-custom.manager';
import { Injectable } from '@nestjs/common';
import { VipCodeEntity } from '../../entities/vip-code.entity';
import { EventTopics } from 'src/core/strings/constants/interface.constants';

@Injectable()
export class GenerateVipCodeManager extends BaseCustomManager<VipCodeEntity> {
  validateProcess(): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  process(): Promise<void> {
    const date = new Date();

    // get month dan year (dua digit)
    const month =
      date.getMonth() < 10
        ? `0${date.getMonth() + 1}`
        : (date.getMonth() + 1).toString();
    const year = date.getFullYear().toString().slice(-2);

    const char = this.generateRandom(1);
    const number = this.generateRandom(2, true);

    this.result = `${month}${year}${char}${number}`;
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get entityTarget(): any {
    return;
  }

  getResult() {
    return this.result;
  }

  get eventTopics(): EventTopics[] {
    return [];
  }

  generateRandom(length: number, is_number?: boolean): string {
    let result = '';
    let base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    if (is_number) base = '123456789';

    let counter = 0;
    while (counter < length) {
      result += base.charAt(Math.floor(Math.random() * base.length));
      counter += 1;
    }

    return result;
  }
}
